# This code is part of the 'enjuewemela' game
# License: GPLv3
# Main author: Facundo Batista
# Code, bug tracker, etc:
#   https://launchpad.net/enjuewemela/
#

"""Easy interface to play sounds."""

#
# original file from http://www.partiallydisassembled.net/make_me/
# modified later for this game
#
from config import MUSIC
import pyglet


#
# MUSIC
#
music_player = pyglet.media.Player()
current_music = None

sound_vol = 0.7
music_player.volume = 0.4

def set_music(name):
    """Set the music to play."""
    # pylint: disable-msg=W0603
    global current_music

    if name == current_music:
        return
    current_music = name

    if not MUSIC:
        return

    music_player.next()
    music_player.queue(pyglet.resource.media(name, streaming=True))
    music_player.play()
    # pyglet bug
    music_player.volume = music_player.volume
    music_player.eos_action = 'loop'

def music_volume(vol):
    """Set the music's volume."""
    music_player.volume = vol

def queue_music(name):
    """Queue music to play."""
    music_player.queue(pyglet.resource.media(name, streaming=True))
    music_player.eos_action = 'next'


def play_music():
    """Play current music."""
    if music_player.playing or not current_music:
        return

    name = current_music
    music_player.next()
    music_player.queue(pyglet.resource.media(name, streaming=True))
    music_player.play()
    music_player.eos_action = 'loop'

@music_player.event
def on_eos():
    """On end of stream."""
    music_player.eos_action = 'loop'


def stop_music():
    """Stop the music."""
    music_player.pause()
